Index: trunk/src/mpr/MPR.CPP
===================================================================
--- trunk/src/mpr/MPR.CPP	(revision 1588)
+++ trunk/src/mpr/MPR.CPP	(revision 1589)
@@ -1,3 +1,3 @@
-/* $Id: MPR.CPP,v 1.4 1999-08-19 16:52:23 phaller Exp $ */
+/* $Id: MPR.CPP,v 1.5 1999-11-04 10:32:35 phaller Exp $ */
 
 /*
@@ -23,11 +23,9 @@
 #include <heapstring.h>
 #include <misc.h>
-#include "mpr.h"
+#include <winnetwk.h>
 
 // Undocumented Stuff
 // MPR.DLL of Windows NT
 
-// MultinetGetConnectionPerformanceA
-// MultinetGetConnectionPerformanceW
 // MultinetGetErrorTextA
 // MultinetGetErrorTextW
@@ -68,9 +66,5 @@
 // WNetSetConnectionA
 // WNetSetConnectionW
-// WNetSetLastErrorA      PH: implemented
-// WNetSetLastErrorW      PH: implemented
 // WNetSupportGlobalEnum
-// WNetUseConnectionA
-// WNetUseConnectionW
 
 
@@ -86,4 +80,49 @@
 } MPRGLOBALS;
 
+
+/*****************************************************************************
+ * Purpose:    The MultinetGetConnectionPerformance finctuion returns information
+ *             about the expected performance of a connection used to access a
+ *             network resource.
+ * Parameters: LPNETRESOURCEA            lpNetResource
+ *             LPNETCONNECTIONINFOSTRUCT lpNetConnectInfoStruct
+ * Variables :
+ * Result    : API-Returncode
+ * Remark    : not documented
+ * Status    : UNTESTED
+ *
+ * Author    : Patrick Haller [Thu, 1999/11/04 19:55]
+ *****************************************************************************/
+
+ODINFUNCTION2(DWORD,                  MultinetGetConnectionPerformanceA,
+              LPNETRESOURCEA,         lpNetResource,
+              LPNETCONNECTINFOSTRUCT, lpNetConnectInfoStruct)
+{
+  dprintf(("MPR:MultinetGetConnectionPerformanceA not implemented.\n"));
+  return (ERROR_NO_NETWORK);
+}
+
+
+/*****************************************************************************
+ * Purpose:    The MultinetGetConnectionPerformance finctuion returns information
+ *             about the expected performance of a connection used to access a
+ *             network resource.
+ * Parameters: LPNETRESOURCEW            lpNetResource
+ *             LPNETCONNECTIONINFOSTRUCT lpNetConnectInfoStruct
+ * Variables :
+ * Result    : API-Returncode
+ * Remark    : not documented
+ * Status    : UNTESTED
+ *
+ * Author    : Patrick Haller [Thu, 1999/11/04 19:55]
+ *****************************************************************************/
+
+ODINFUNCTION2(DWORD,                  MultinetGetConnectionPerformanceW,
+              LPNETRESOURCEW,         lpNetResource,
+              LPNETCONNECTINFOSTRUCT, lpNetConnectInfoStruct)
+{
+  dprintf(("MPR:MultinetGetConnectionPerformanceW not implemented.\n"));
+  return (ERROR_NO_NETWORK);
+}
 
 
@@ -106,5 +145,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetAddConnection2A,
+ODINFUNCTION4(DWORD, WNetAddConnection2A,
               LPNETRESOURCEA, lpNetResource,
               LPCSTR, lpPassword,
@@ -135,5 +174,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetAddConnection2W,
+ODINFUNCTION4(DWORD, WNetAddConnection2W,
               LPNETRESOURCEW, lpNetResource,
               LPCWSTR, lpPassword,
@@ -166,5 +205,5 @@
  *****************************************************************************/
 
-ODINFUNCTION5(DWORD, OS2WNetAddConnection3A,
+ODINFUNCTION5(DWORD, WNetAddConnection3A,
               HWND, hwndOwner,
               LPNETRESOURCEA, lpNetResource,
@@ -197,5 +236,5 @@
  *****************************************************************************/
 
-ODINFUNCTION5(DWORD, OS2WNetAddConnection3W,
+ODINFUNCTION5(DWORD, WNetAddConnection3W,
               HWND, hwndOwner,
               LPNETRESOURCEW, lpNetResource,
@@ -224,5 +263,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetAddConnectionA,
+ODINFUNCTION3(DWORD, WNetAddConnectionA,
               LPCSTR, lpRemoteName,
               LPCSTR, lpPassword,
@@ -249,5 +288,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetAddConnectionW,
+ODINFUNCTION3(DWORD, WNetAddConnectionW,
               LPCWSTR, lpRemoteName,
               LPCWSTR, lpPassword,
@@ -275,5 +314,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetCancelConnection2A,
+ODINFUNCTION3(DWORD, WNetCancelConnection2A,
               LPTSTR, lpszName,
               DWORD, fdwConnection,
@@ -301,5 +340,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetCancelConnection2W,
+ODINFUNCTION3(DWORD, WNetCancelConnection2W,
               LPWSTR, lpszName,
               DWORD, fdwConnection,
@@ -324,5 +363,5 @@
  *****************************************************************************/
 
-ODINFUNCTION2(DWORD, OS2WNetCancelConnectionA,
+ODINFUNCTION2(DWORD, WNetCancelConnectionA,
               LPTSTR, lpszName,
               BOOL, fForce)
@@ -346,5 +385,5 @@
  *****************************************************************************/
 
-ODINFUNCTION2(DWORD, OS2WNetCancelConnectionW,
+ODINFUNCTION2(DWORD, WNetCancelConnectionW,
               LPWSTR, lpszName,
               BOOL, fForce)
@@ -368,5 +407,5 @@
  *****************************************************************************/
 
-ODINFUNCTION1(DWORD, OS2WNetCloseEnum,
+ODINFUNCTION1(DWORD, WNetCloseEnum,
               HANDLE, hEnum)
 {
@@ -389,5 +428,5 @@
  *****************************************************************************/
 
-ODINFUNCTION2(DWORD, OS2WNetConnectionDialog,
+ODINFUNCTION2(DWORD, WNetConnectionDialog,
               HWND, hwnd,
               DWORD, fdwResourceType)
@@ -411,5 +450,5 @@
  *****************************************************************************/
 
-ODINFUNCTION2(DWORD, OS2WNetDisconnectDialog,
+ODINFUNCTION2(DWORD, WNetDisconnectDialog,
               HWND, hwnd,
               DWORD, fdwResourceType)
@@ -435,5 +474,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetEnumResourceA,
+ODINFUNCTION4(DWORD, WNetEnumResourceA,
               HANDLE, hEnum,
               LPDWORD, lpcEntries,
@@ -461,5 +500,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetEnumResourceW,
+ODINFUNCTION4(DWORD, WNetEnumResourceW,
               HANDLE, hEnum,
               LPDWORD, lpcEntries,
@@ -486,5 +525,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetGetConnectionA,
+ODINFUNCTION3(DWORD, WNetGetConnectionA,
               LPTSTR, lpszLocalName,
               LPTSTR, lpszRemoteName,
@@ -510,5 +549,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetGetConnectionW,
+ODINFUNCTION3(DWORD, WNetGetConnectionW,
               LPWSTR, lpszLocalName,
               LPWSTR, lpszRemoteName,
@@ -536,5 +575,5 @@
  *****************************************************************************/
 
-ODINFUNCTION5(DWORD, OS2WNetGetLastErrorA,
+ODINFUNCTION5(DWORD, WNetGetLastErrorA,
               LPDWORD, lpdwErrorCode,
               LPTSTR, lpszDescription,
@@ -580,5 +619,5 @@
  *****************************************************************************/
 
-ODINFUNCTION5(DWORD, OS2WNetGetLastErrorW,
+ODINFUNCTION5(DWORD, WNetGetLastErrorW,
               LPDWORD, lpdwErrorCode,
               LPWSTR, lpszDescription,
@@ -630,5 +669,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetGetResourceInformationA,
+ODINFUNCTION4(DWORD, WNetGetResourceInformationA,
               LPNETRESOURCEA, lpNetResource,
               LPVOID, lpBuffer,
@@ -664,5 +703,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetGetResourceInformationW,
+ODINFUNCTION4(DWORD, WNetGetResourceInformationW,
               LPNETRESOURCEW, lpNetResource,
               LPVOID, lpBuffer,
@@ -696,5 +735,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetGetResourceParentA,
+ODINFUNCTION3(DWORD, WNetGetResourceParentA,
               LPNETRESOURCEA, lpNetResource,
               LPVOID, lpBuffer,
@@ -722,5 +761,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetGetResourceParentW,
+ODINFUNCTION3(DWORD, WNetGetResourceParentW,
               LPNETRESOURCEW, lpNetResource,
               LPVOID, lpBuffer,
@@ -748,5 +787,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetGetUniversalNameA,
+ODINFUNCTION4(DWORD, WNetGetUniversalNameA,
               LPCSTR, lpLocalPath,
               DWORD, dwInfoLevel,
@@ -775,5 +814,5 @@
  *****************************************************************************/
 
-ODINFUNCTION4(DWORD, OS2WNetGetUniversalNameW,
+ODINFUNCTION4(DWORD, WNetGetUniversalNameW,
               LPCWSTR, lpLocalPath,
               DWORD, dwInfoLevel,
@@ -800,5 +839,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetGetUserA,
+ODINFUNCTION3(DWORD, WNetGetUserA,
               LPTSTR, lpszLocalName,
               LPTSTR, lpszUserName,
@@ -824,5 +863,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetGetUserW,
+ODINFUNCTION3(DWORD, WNetGetUserW,
               LPWSTR, lpszLocalName,
               LPWSTR, lpszUserName,
@@ -850,5 +889,5 @@
  *****************************************************************************/
 
-ODINFUNCTION5(DWORD, OS2WNetOpenEnumA,
+ODINFUNCTION5(DWORD, WNetOpenEnumA,
               DWORD, fdwScope,
               DWORD, fdwType,
@@ -878,5 +917,5 @@
  *****************************************************************************/
 
-ODINFUNCTION5(DWORD, OS2WNetOpenEnumW,
+ODINFUNCTION5(DWORD, WNetOpenEnumW,
               DWORD, fdwScope,
               DWORD, fdwType,
@@ -904,5 +943,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetSetLastErrorA,
+ODINFUNCTION3(DWORD, WNetSetLastErrorA,
               DWORD, dwErrorCode,
               LPTSTR, lpszDescription,
@@ -930,5 +969,5 @@
  *****************************************************************************/
 
-ODINFUNCTION3(DWORD, OS2WNetSetLastErrorW,
+ODINFUNCTION3(DWORD, WNetSetLastErrorW,
               DWORD, dwErrorCode,
               LPWSTR, lpszDescription,
@@ -941,2 +980,71 @@
 
 
+/*****************************************************************************
+ * Purpose:    The WNetUSeConnectionA function is used to establish a connection
+ *             to a network object, especially for browsing. The function may
+ *             optionally prompt the user for login or authentification.
+ * Parameters: HWND           hwndOwner
+ *             LPNETRESOURCEA lpNetResource
+ *             LPSTR          lpPassword
+ *             LPSTR          lpUserID
+ *             DWORD          dwFlags
+ *             LPSTR          lpAccessName
+ *             LPDWORD        lpBufferSize
+ *             LPDWORD        lpResult
+ * Variables :
+ * Result    : API-Returncode
+ * Remark    : not documented
+ * Status    : UNTESTED
+ *
+ * Author    : Patrick Haller [Thu, 1999/11/04 19:55]
+ *****************************************************************************/
+
+ODINFUNCTION8(DWORD,         WNetUseConnectionA,
+              HWND,          hwndOwner,
+              LPNETRESOURCEA,lpNetResource,
+              LPSTR,         lpPassword,
+              LPSTR,         lpUserID,
+              DWORD,         dwFlags,
+              LPSTR,         lpAccessName,
+              LPDWORD,       lpBufferSize,
+              LPDWORD,       lpResult)
+{
+  dprintf(("MPR:WNetUseConnectionA not implemented.\n"));
+  return (ERROR_NO_NETWORK);
+}
+
+
+/*****************************************************************************
+ * Purpose:    The WNetUSeConnectionW function is used to establish a connection
+ *             to a network object, especially for browsing. The function may
+ *             optionally prompt the user for login or authentification.
+ * Parameters: HWND           hwndOwner
+ *             LPNETRESOURCEW lpNetResource
+ *             LPWSTR         lpPassword
+ *             LPWSTR         lpUserID
+ *             DWORD          dwFlags
+ *             LPWSTR         lpAccessName
+ *             LPDWORD        lpBufferSize
+ *             LPDWORD        lpResult
+ * Variables :
+ * Result    : API-Returncode
+ * Remark    : not documented
+ * Status    : UNTESTED
+ *
+ * Author    : Patrick Haller [Thu, 1999/11/04 19:55]
+ *****************************************************************************/
+
+ODINFUNCTION8(DWORD,         WNetUseConnectionW,
+              HWND,          hwndOwner,
+              LPNETRESOURCEW,lpNetResource,
+              LPWSTR,        lpPassword,
+              LPWSTR,        lpUserID,
+              DWORD,         dwFlags  ,
+              LPWSTR,        lpAccessName,
+              LPDWORD,       lpBufferSize,
+              LPDWORD,       lpResult)
+{
+  dprintf(("MPR:WNetUseConnectionW not implemented.\n"));
+  return (ERROR_NO_NETWORK);
+}
+
Index: trunk/src/mpr/MPR.DEF
===================================================================
--- trunk/src/mpr/MPR.DEF	(revision 1588)
+++ trunk/src/mpr/MPR.DEF	(revision 1589)
@@ -1,3 +1,3 @@
-; $Id: MPR.DEF,v 1.2 1999-06-10 17:06:06 phaller Exp $
+; $Id: MPR.DEF,v 1.3 1999-11-04 10:32:36 phaller Exp $
 
 ;Created by BLAST for IBMs compiler
@@ -8,78 +8,79 @@
 EXPORTS
 
-; MultinetGetConnectionPerformanceA@1  = _OS2MultinetGetConnectionPerformanceA@?? @1
-; MultinetGetConnectionPerformanceW@2  = _OS2MultinetGetConnectionPerformanceW@?? @2
-; MultinetGetErrorTextA@3              = _OS2MultinetGetErrorTextA@??             @3
-; MultinetGetErrorTextW@4              = _OS2MultinetGetErrorTextW@??             @4
-; RestoreConnectionA0@5                = _OS2RestoreConnectionA0@??               @5
-  WNetAddConnection2A                  = _OS2WNetAddConnection2A@16               @6
-  WNetAddConnection2W                  = _OS2WNetAddConnection2W@16               @7
-  WNetAddConnection3A                  = _OS2WNetAddConnection3A@20               @8
-  WNetAddConnection3W                  = _OS2WNetAddConnection3W@20               @9
-  WNetAddConnectionA                   = _OS2WNetAddConnectionA@12                @10
-  WNetAddConnectionW                   = _OS2WNetAddConnectionW@12                @11
-  WNetCancelConnection2A               = _OS2WNetCancelConnection2A@12            @12
-  WNetCancelConnection2W               = _OS2WNetCancelConnection2W@12            @13
-  WNetCancelConnectionA                = _OS2WNetCancelConnectionA@8              @14
-  WNetCancelConnectionW                = _OS2WNetCancelConnectionW@8              @15
-; WNetClearConnections                 = _OS2WNetClearConnections@??              @16
-  WNetCloseEnum                        = _OS2WNetCloseEnum@4                      @17
-; WNetConnectionDialog1A               = _OS2WNetConnectionDialog1A@??            @18
-; WNetConnectionDialog1W               = _OS2WNetConnectionDialog1W@??            @19
-; WNetConnectionDialog2                = _OS2WNetConnectionDialog2@??             @20
-  WNetConnectionDialog                 = _OS2WNetConnectionDialog@8               @21
-; WNetDirectoryNotifyA                 = _OS2WNetDirectoryNotifyA@??              @22
-; WNetDirectoryNotifyW                 = _OS2WNetDirectoryNotifyW@??              @23
-; WNetDisconnectDialog1A               = _OS2WNetDisconnectDialog1A@??            @24
-; WNetDisconnectDialog1W               = _OS2WNetDisconnectDialog1W@??            @25
-; WNetDisconnectDialog2                = _OS2WNetDisconnectDialog2@??             @26
-  WNetDisconnectDialog                 = _OS2WNetDisconnectDialog@8               @27
-  WNetEnumResourceA                    = _OS2WNetEnumResourceA@16                 @28
-  WNetEnumResourceW                    = _OS2WNetEnumResourceW@16                 @29
-; WNetFMXEditPerm                      = _OS2WNetFMXEditPerm@??                   @30
-; WNetFMXGetPermCaps                   = _OS2WNetFMXGetPermCaps@??                @31
-; WNetFMXGetPermHelp                   = _OS2WNetFMXGetPermHelp@??                @32
-; WNetFormatNetworkNameA               = _OS2WNetGetNetworkNameA@??               @33
-; WNetFormatNetworkNameW               = _OS2WNetGetNetworkNameW@??               @34
-; WNetGetConnection2A                  = _OS2WNetGetConnection2A@??               @35
-; WNetGetConnection2W                  = _OS2WNetGetConnection2W@??               @36
-; WNetGetConnection3A                  = _OS2WNetGetConnection3A@??               @37
-; WNetGetConnection3W                  = _OS2WNetGetConnection3W@??               @38
-  WNetGetConnectionA                   = _OS2WNetGetConnectionA@12                @39
-  WNetGetConnectionW                   = _OS2WNetGetConnectionW@12                @40
-; WNetGetDirectoryTypeA                = _OS2WNetGetDirectoryTypeA@??             @41
-; WNetGetDirectoryTypeW                = _OS2WNetGetDirectoryTypeW@??             @42
-; WNetGetHomeDirectoryW                = _OS2WNetGetHomeDirectoryW@??             @43
-  WNetGetLastErrorA                    = _OS2WNetGetLastErrorA@20                 @44
-  WNetGetLastErrorW                    = _OS2WNetGetLastErrorW@20                 @45
-; WNetGetNetworkInformationA           = _OS2WNetGetNetworkInformationA@??        @46
-; WNetGetNetworkInformationW           = _OS2WNetGetNetworkInformationW@??        @47
-; WNetGetPropertyTextA                 = _OS2WNetGetPropertyTextA@??              @48
-; WNetGetPropertyTextW                 = _OS2WNetGetPropertyTextW@??              @49
-; WNetGetProviderNameA                 = _OS2WNetGetProviderNameA@??              @50
-; WNetGetProviderNameW                 = _OS2WNetGetProviderNameW@??              @51
-; WNetGetProviderTypeA                 = _OS2WNetGetProviderTypeA@??              @52
-; WNetGetProviderTypeW                 = _OS2WNetGetProviderTypeW@??              @53
-  WNetGetResourceInformationA          = _OS2WNetGetResourceInformationA@16       @54
-  WNetGetResourceInformationW          = _OS2WNetGetResourceInformationW@16       @55
-  WNetGetResourceParentA               = _OS2WNetGetResourceParentA@12            @56
-  WNetGetResourceParentW               = _OS2WNetGetResourceParentW@12            @57
-; WNetGetSearchDialog                  = _OS2WNetGetSearchDialog@??               @58
-  WNetGetUniversalNameA                = _OS2WNetGetUniversalNameA@16             @59
-  WNetGetUniversalNameW                = _OS2WNetGetUniversalNameW@16             @60
-  WNetGetUserA                         = _OS2WNetGetUserA@12                      @61
-  WNetGetUserW                         = _OS2WNetGetUserW@12                      @62
-; WNetLogonNotify                      = _OS2WNetLogonNotify@??                   @63
-  WNetOpenEnumA                        = _OS2WNetOpenEnumA@20                     @64
-  WNetOpenEnumW                        = _OS2WNetOpenEnumW@20                     @65
-; WNetPasswordChangeNotify             = _OS2WNetPasswordChangeNotify@??          @66
-; WNetPropertyDialogA                  = _OS2WNetPropertyDialogA@??               @67
-; WNetPropertyDialogW                  = _OS2WNetPropertyDialogW@??               @68
-; WNetRestoreConnectionW               = _OS2WNetRestoreConnection@??             @69
-; WNetSetConnectionA                   = _OS2WNetSetConnectionA@??                @70
-; WNetSetConnectionW                   = _OS2WNetSetConnectionW@??                @71
-  WNetSetLastErrorA                    = _OS2WNetSetLastErrorA@12                 @72
-  WNetSetLastErrorW                    = _OS2WNetSetLastErrorW@12                 @73
-; WNetSupportGlobalEnum                = _OS2WNetSupportGlobalEnum@??             @74
-; WNetUseConnectionA                   = _OS2WNetUseConnectionA@??                @75
-; WNetUseConnectionW                   = _OS2WnetUseConnectionW@??                @76
+  MultinetGetConnectionPerformanceA@1  = _MultinetGetConnectionPerformanceA@8  @1
+  MultinetGetConnectionPerformanceW@2  = _MultinetGetConnectionPerformanceW@8  @2
+; MultinetGetErrorTextA@3              = _MultinetGetErrorTextA@??             @3
+; MultinetGetErrorTextW@4              = _MultinetGetErrorTextW@??             @4
+; RestoreConnectionA0@5                = _RestoreConnectionA0@??               @5
+  WNetAddConnection2A                  = _WNetAddConnection2A@16               @6
+  WNetAddConnection2W                  = _WNetAddConnection2W@16               @7
+  WNetAddConnection3A                  = _WNetAddConnection3A@20               @8
+  WNetAddConnection3W                  = _WNetAddConnection3W@20               @9
+  WNetAddConnectionA                   = _WNetAddConnectionA@12                @10
+  WNetAddConnectionW                   = _WNetAddConnectionW@12                @11
+  WNetCancelConnection2A               = _WNetCancelConnection2A@12            @12
+  WNetCancelConnection2W               = _WNetCancelConnection2W@12            @13
+  WNetCancelConnectionA                = _WNetCancelConnectionA@8              @14
+  WNetCancelConnectionW                = _WNetCancelConnectionW@8              @15
+; WNetClearConnections                 = _WNetClearConnections@??              @16
+  WNetCloseEnum                        = _WNetCloseEnum@4                      @17
+; WNetConnectionDialog1A               = _WNetConnectionDialog1A@??            @18
+; WNetConnectionDialog1W               = _WNetConnectionDialog1W@??            @19
+; WNetConnectionDialog2                = _WNetConnectionDialog2@??             @20
+  WNetConnectionDialog                 = _WNetConnectionDialog@8               @21
+; WNetDirectoryNotifyA                 = _WNetDirectoryNotifyA@??              @22
+; WNetDirectoryNotifyW                 = _WNetDirectoryNotifyW@??              @23
+; WNetDisconnectDialog1A               = _WNetDisconnectDialog1A@??            @24
+; WNetDisconnectDialog1W               = _WNetDisconnectDialog1W@??            @25
+; WNetDisconnectDialog2                = _WNetDisconnectDialog2@??             @26
+  WNetDisconnectDialog                 = _WNetDisconnectDialog@8               @27
+  WNetEnumResourceA                    = _WNetEnumResourceA@16                 @28
+  WNetEnumResourceW                    = _WNetEnumResourceW@16                 @29
+; WNetFMXEditPerm                      = _WNetFMXEditPerm@??                   @30
+; WNetFMXGetPermCaps                   = _WNetFMXGetPermCaps@??                @31
+; WNetFMXGetPermHelp                   = _WNetFMXGetPermHelp@??                @32
+; WNetFormatNetworkNameA               = _WNetGetNetworkNameA@??               @33
+; WNetFormatNetworkNameW               = _WNetGetNetworkNameW@??               @34
+; WNetGetConnection2A                  = _WNetGetConnection2A@??               @35
+; WNetGetConnection2W                  = _WNetGetConnection2W@??               @36
+; WNetGetConnection3A                  = _WNetGetConnection3A@??               @37
+; WNetGetConnection3W                  = _WNetGetConnection3W@??               @38
+  WNetGetConnectionA                   = _WNetGetConnectionA@12                @39
+  WNetGetConnectionW                   = _WNetGetConnectionW@12                @40
+; WNetGetDirectoryTypeA                = _WNetGetDirectoryTypeA@??             @41
+; WNetGetDirectoryTypeW                = _WNetGetDirectoryTypeW@??             @42
+; WNetGetHomeDirectoryW                = _WNetGetHomeDirectoryW@??             @43
+  WNetGetLastErrorA                    = _WNetGetLastErrorA@20                 @44
+  WNetGetLastErrorW                    = _WNetGetLastErrorW@20                 @45
+; WNetGetNetworkInformationA           = _WNetGetNetworkInformationA@??        @46
+; WNetGetNetworkInformationW           = _WNetGetNetworkInformationW@??        @47
+; WNetGetPropertyTextA                 = _WNetGetPropertyTextA@??              @48
+; WNetGetPropertyTextW                 = _WNetGetPropertyTextW@??              @49
+; WNetGetProviderNameA                 = _WNetGetProviderNameA@??              @50
+; WNetGetProviderNameW                 = _WNetGetProviderNameW@??              @51
+; WNetGetProviderTypeA                 = _WNetGetProviderTypeA@??              @52
+; WNetGetProviderTypeW                 = _WNetGetProviderTypeW@??              @53
+  WNetGetResourceInformationA          = _WNetGetResourceInformationA@16       @54
+  WNetGetResourceInformationW          = _WNetGetResourceInformationW@16       @55
+  WNetGetResourceParentA               = _WNetGetResourceParentA@12            @56
+  WNetGetResourceParentW               = _WNetGetResourceParentW@12            @57
+; WNetGetSearchDialog                  = _WNetGetSearchDialog@??               @58
+  WNetGetUniversalNameA                = _WNetGetUniversalNameA@16             @59
+  WNetGetUniversalNameW                = _WNetGetUniversalNameW@16             @60
+  WNetGetUserA                         = _WNetGetUserA@12                      @61
+  WNetGetUserW                         = _WNetGetUserW@12                      @62
+; WNetLogonNotify                      = _WNetLogonNotify@??                   @63
+  WNetOpenEnumA                        = _WNetOpenEnumA@20                     @64
+  WNetOpenEnumW                        = _WNetOpenEnumW@20                     @65
+; WNetPasswordChangeNotify             = _WNetPasswordChangeNotify@??          @66
+; WNetPropertyDialogA                  = _WNetPropertyDialogA@??               @67
+; WNetPropertyDialogW                  = _WNetPropertyDialogW@??               @68
+; WNetRestoreConnectionW               = _WNetRestoreConnection@??             @69
+; WNetSetConnectionA                   = _WNetSetConnectionA@??                @70
+; WNetSetConnectionW                   = _WNetSetConnectionW@??                @71
+  WNetSetLastErrorA                    = _WNetSetLastErrorA@12                 @72
+  WNetSetLastErrorW                    = _WNetSetLastErrorW@12                 @73
+; WNetSupportGlobalEnum                = _WNetSupportGlobalEnum@??             @74
+  WNetUseConnectionA                   = _WNetUseConnectionA@32                @75
+  WNetUseConnectionW                   = _WNetUseConnectionW@32                @76
+
Index: trunk/src/mpr/mpr.h
===================================================================
--- trunk/src/mpr/mpr.h	(revision 1588)
+++ 	(revision )
@@ -1,180 +1,0 @@
-/* $Id: mpr.h,v 1.3 1999-06-10 17:06:06 phaller Exp $ */
-
-/*
- *
- * Project Odin Software License can be found in LICENSE.TXT
- *
- */
-/*
- * MPR apis
- *
- * 1998/06/12
- *
- * Copyright 1998 Patrick Haller
- */
-/*****************************************************************************
- * Name      : MPR.H
- * Purpose   : This module maps all Win32 functions contained in MPR.DLL
- *             to their OS/2-specific counterparts as far as possible.
- *             Basis is  5.05.97  12.00  59152 MPR.DLL (NT4SP3)
- *****************************************************************************/
-
-
-#ifndef __MPR_H__
-#define __MPR_H__
-
-#define WINVER    0x400
-#undef  APIENTRY
-#define APIENTRY  WIN32API
-#define FAR
-
-#include <winnetwk.h>
-
-/****************************************************************************
- * Prototypes                                                               *
- ****************************************************************************/
-
-DWORD WIN32API OS2WNetAddConnection2A(LPNETRESOURCEA lpNetResource,
-                                      LPCSTR       lpPassword,
-                                      LPCSTR       lpUsername,
-                                      DWORD         fdwConnection);
-
-DWORD WIN32API OS2WNetAddConnection2W(LPNETRESOURCEW lpNetResource,
-                                      LPCWSTR       lpPassword,
-                                      LPCWSTR       lpUsername,
-                                      DWORD         fdwConnection);
-
-DWORD WIN32API OS2WNetAddConnection3A(HWND          hwndOwner,
-                                      LPNETRESOURCEA lpNetResource,
-                                      LPCSTR       lpPassword,
-                                      LPCSTR       lpUsername,
-                                      DWORD         fdwConnection);
-
-DWORD WIN32API OS2WNetAddConnection3W(HWND          hwndOwner,
-                                      LPNETRESOURCEW lpNetResource,
-                                      LPCWSTR       lpPassword,
-                                      LPCWSTR       lpUsername,
-                                      DWORD         fdwConnection);
-
-DWORD WIN32API OS2WNetAddConnectionA(LPCSTR lpRemoteName,
-                                     LPCSTR lpPassword,
-                                     LPCSTR lpUsername);
-
-DWORD WIN32API OS2WNetAddConnectionW(LPCWSTR lpRemoteName,
-                                     LPCWSTR lpPassword,
-                                     LPCWSTR lpUsername);
-
-DWORD WIN32API OS2WNetCancelConnection2A(LPTSTR lpszName,
-                                         DWORD  fdwConnection,
-                                         BOOL   fForce);
-
-DWORD WIN32API OS2WNetCancelConnection2W(LPWSTR lpszName,
-                                         DWORD  fdwConnection,
-                                         BOOL   fForce);
-
-DWORD WIN32API OS2WNetCancelConnectionA(LPTSTR lpszName,
-                                        BOOL   fForce);
-
-DWORD WIN32API OS2WNetCancelConnectionW(LPWSTR lpszName,
-                                        BOOL   fForce);
-
-DWORD WIN32API OS2WNetCloseEnum (HANDLE hEnum);
-
-DWORD WIN32API OS2WNetConnectionDialog (HWND  hwnd,
-                                        DWORD fdwResourceType);
-
-DWORD WIN32API OS2WNetDisconnectDialog (HWND  hwnd,
-                                        DWORD fdwResourceType);
-
-DWORD WIN32API OS2WNetEnumResourceA (HANDLE  hEnum,
-                                     LPDWORD lpcEntries,
-                                     LPVOID  lpvBuffer,
-                                     LPDWORD lpcBuffer);
-
-DWORD WIN32API OS2WNetEnumResourceW (HANDLE  hEnum,
-                                     LPDWORD lpcEntries,
-                                     LPVOID  lpvBuffer,
-                                     LPDWORD lpcBuffer);
-
-DWORD WIN32API OS2WNetGetConnectionA (LPTSTR lpszLocalName,
-                                      LPTSTR lpszRemoteName,
-                                      LPDWORD lpcchBuffer);
-
-DWORD WIN32API OS2WNetGetConnectionW (LPWSTR lpszLocalName,
-                                      LPWSTR lpszRemoteName,
-                                      LPDWORD lpcchBuffer);
-
-DWORD WIN32API OS2WNetGetLastErrorA (LPDWORD lpdwErrorCode,
-                                     LPTSTR  lpszDescription,
-                                     DWORD   cchDescription,
-                                     LPTSTR  lpszName,
-                                     DWORD   cchName);
-
-DWORD WIN32API OS2WNetGetLastErrorW (LPDWORD lpdwErrorCode,
-                                     LPWSTR  lpszDescription,
-                                     DWORD   cchDescription,
-                                     LPWSTR  lpszName,
-                                     DWORD   cchName);
-
-DWORD WIN32API OS2WNetGetResourceInformationA(LPNETRESOURCEA lpNetResource,
-                                              LPVOID         lpBuffer,
-                                              LPDWORD        cbBuffer,
-                                              LPTSTR         *lplpSystem);
-
-DWORD WIN32API OS2WNetGetResourceInformationW(LPNETRESOURCEW lpNetResource,
-                                              LPVOID         lpBuffer,
-                                              LPDWORD        cbBuffer,
-                                              LPWSTR         *lplpSystem);
-
-DWORD WIN32API OS2WNetGetResourceParentA(LPNETRESOURCEA lpNetResource,
-                                         LPVOID         lpBuffer,
-                                         LPDWORD        lpBufferSize);
-
-DWORD WIN32API OS2WNetGetResourceParentW(LPNETRESOURCEW lpNetResource,
-                                         LPVOID         lpBuffer,
-                                         LPDWORD        lpBufferSize);
-
-DWORD WIN32API OS2WNetGetUniversalNameA(LPCSTR  lpLocalPath,
-                                        DWORD   dwInfoLevel,
-                                        LPVOID  lpBuffer,
-                                        LPDWORD lpBufferSize);
-
-DWORD WIN32API OS2WNetGetUniversalNameW(LPCWSTR lpLocalPath,
-                                        DWORD   dwInfoLevel,
-                                        LPVOID  lpBuffer,
-                                        LPDWORD lpBufferSize);
-
-DWORD WIN32API OS2WNetGetUserA(LPTSTR  lpszLocalName,
-                               LPTSTR  lpszUserName,
-                               LPDWORD lpcchBuffer);
-
-DWORD WIN32API OS2WNetGetUserW(LPWSTR  lpszLocalName,
-                               LPWSTR  lpszUserName,
-                               LPDWORD lpcchBuffer);
-
-DWORD WIN32API OS2WNetOpenEnumA(DWORD          fdwScope,
-                                DWORD          fdwType,
-                                DWORD          fdwUsage,
-                                LPNETRESOURCEA lpNetResource,
-                                LPHANDLE       lphEnum);
-
-DWORD WIN32API OS2WNetOpenEnumW(DWORD          fdwScope,
-                                DWORD          fdwType,
-                                DWORD          fdwUsage,
-                                LPNETRESOURCEW lpNetResource,
-                                LPHANDLE       lphEnum);
-
-DWORD WIN32API OS2WNetSetLastErrorA (DWORD   dwErrorCode,
-                                     LPTSTR  lpszDescription,
-                                     LPTSTR  lpszName);
-
-DWORD WIN32API OS2WNetSetLastErrorW (DWORD   dwErrorCode,
-                                     LPWSTR  lpszDescription,
-                                     LPWSTR  lpszName);
-
-
-
-
-
-
-#endif