Index: trunk/kBuild/tools/GCC3.kmk
===================================================================
--- trunk/kBuild/tools/GCC3.kmk	(revision 1603)
+++ trunk/kBuild/tools/GCC3.kmk	(revision 1612)
@@ -25,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -60,4 +60,7 @@
  TOOL_GCC3_LD_MAP ?= -Zmap=$(1)
  TOOL_GCC3_LD_SYSMOD_MAP ?= -Zmap=$(1)
+else
+ TOOL_GCC3_LD_MAP ?=
+ TOOL_GCC3_LD_SYSMOD_MAP ?=
 endif
 ifdef SLKRUNS
Index: trunk/kBuild/tools/GCC32.kmk
===================================================================
--- trunk/kBuild/tools/GCC32.kmk	(revision 1603)
+++ trunk/kBuild/tools/GCC32.kmk	(revision 1612)
@@ -25,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -52,10 +52,10 @@
 TOOL_GCC32_LD_MAP ?= -Zmap=$(1)
 else
-TOOL_GCC32_LD_MAP ?= -Wl,-Map -Wl,$(1) -Wl,--cref
+TOOL_GCC32_LD_MAP ?=
 endif
 ifeq ($(KBUILD_TARGET),os2)
 TOOL_GCC32_LD_SYSMOD_MAP ?= -Zmap=$(1)
 else
-TOOL_GCC32_LD_SYSMOD_MAP ?= -Map $(1) --cref
+TOOL_GCC32_LD_SYSMOD_MAP ?=
 endif
 ifdef SLKRUNS
Index: trunk/kBuild/tools/GCC3PLAIN.kmk
===================================================================
--- trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 1603)
+++ trunk/kBuild/tools/GCC3PLAIN.kmk	(revision 1612)
@@ -25,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -311,6 +311,5 @@
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))\
-		$(call TOOL_GCC3PLAIN_LD_SYSMOD_MAP.$(bld_trg),$(outbase).map)
-endef
-
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
+endef
+
Index: trunk/kBuild/tools/GCC64.kmk
===================================================================
--- trunk/kBuild/tools/GCC64.kmk	(revision 1603)
+++ trunk/kBuild/tools/GCC64.kmk	(revision 1612)
@@ -25,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -52,10 +52,10 @@
 TOOL_GCC64_LD_MAP ?= -Zmap=$(1)
 else
-TOOL_GCC64_LD_MAP ?= -Wl,-Map -Wl,$(1) -Wl,--cref
+TOOL_GCC64_LD_MAP ?=
 endif
 ifeq ($(KBUILD_TARGET),os2)
 TOOL_GCC64_LD_SYSMOD_MAP ?= -Zmap=$(1)
 else
-TOOL_GCC64_LD_SYSMOD_MAP ?= -Map $(1) --cref
+TOOL_GCC64_LD_SYSMOD_MAP ?=
 endif
 ifdef SLKRUNS
Index: trunk/kBuild/tools/GXX3.kmk
===================================================================
--- trunk/kBuild/tools/GXX3.kmk	(revision 1603)
+++ trunk/kBuild/tools/GXX3.kmk	(revision 1612)
@@ -26,6 +26,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -61,4 +61,7 @@
  TOOL_GXX3_LD_MAP ?= -Zmap=$(1)
  TOOL_GXX3_LD_SYSMOD_MAP ?= -Zmap=$(1)
+else
+ TOOL_GXX3_LD_MAP ?=
+ TOOL_GXX3_LD_SYSMOD_MAP ?=
 endif
 ifdef SLKRUNS
Index: trunk/kBuild/tools/GXX32.kmk
===================================================================
--- trunk/kBuild/tools/GXX32.kmk	(revision 1603)
+++ trunk/kBuild/tools/GXX32.kmk	(revision 1612)
@@ -25,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -52,10 +52,10 @@
 TOOL_GXX32_LD_MAP ?= -Zmap=$(1)
 else
-TOOL_GXX32_LD_MAP ?= -Wl,-Map -Wl,$(1) -Wl,--cref
+TOOL_GXX32_LD_MAP ?=
 endif
 ifeq ($(KBUILD_TARGET),os2)
 TOOL_GXX32_LD_SYSMOD_MAP ?= -Zmap=$(1)
 else
-TOOL_GXX32_LD_SYSMOD_MAP ?= -Map $(1) --cref
+TOOL_GXX32_LD_SYSMOD_MAP ?=
 endif
 ifdef SLKRUNS
Index: trunk/kBuild/tools/GXX3PLAIN.kmk
===================================================================
--- trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 1603)
+++ trunk/kBuild/tools/GXX3PLAIN.kmk	(revision 1612)
@@ -25,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -311,6 +311,5 @@
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))\
-		$(call TOOL_GXX3PLAIN_LD_SYSMOD_MAP.$(bld_trg),$(outbase).map)
-endef
-
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))
+endef
+
Index: trunk/kBuild/tools/GXX64.kmk
===================================================================
--- trunk/kBuild/tools/GXX64.kmk	(revision 1603)
+++ trunk/kBuild/tools/GXX64.kmk	(revision 1612)
@@ -25,6 +25,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -52,10 +52,10 @@
 TOOL_GXX64_LD_MAP ?= -Zmap=$(1)
 else
-TOOL_GXX64_LD_MAP ?= -Wl,-Map -Wl,$(1) -Wl,--cref
+TOOL_GXX64_LD_MAP ?=
 endif
 ifeq ($(KBUILD_TARGET),os2)
 TOOL_GXX64_LD_SYSMOD_MAP ?= -Zmap=$(1)
 else
-TOOL_GXX64_LD_SYSMOD_MAP ?= -Map $(1) --cref
+TOOL_GXX64_LD_SYSMOD_MAP ?=
 endif
 ifdef SLKRUNS
Index: trunk/kBuild/tools/MINGW32.kmk
===================================================================
--- trunk/kBuild/tools/MINGW32.kmk	(revision 1603)
+++ trunk/kBuild/tools/MINGW32.kmk	(revision 1612)
@@ -26,6 +26,6 @@
 #
 # As a special exception you are granted permission to include this file, via
-# the kmk include directive, as you wish without this in itself causing the 
-# resulting makefile, program or whatever to be covered by the GPL license. 
+# the kmk include directive, as you wish without this in itself causing the
+# resulting makefile, program or whatever to be covered by the GPL license.
 # This exception does not however invalidate any other reasons why the makefile,
 # program, whatever should not be covered the GPL.
@@ -85,6 +85,4 @@
 TOOL_MINGW32_LD  ?= $(TOOL_MINGW32_PREFIX)gcc$(TOOL_MINGW32_HOSTSUFF_EXE)
 endif
-TOOL_MINGW32_LD_MAP ?= -Wl,-Map -Wl,$(1) -Wl,--cref
-TOOL_MINGW32_LD_SYSMOD_MAP ?= -Map $(1) --cref
 TOOL_MINGW32_DLLWRAP ?= $(TOOL_MINGW32_PREFIX)dllwrap$(TOOL_MINGW32_HOSTSUFF_EXE)
 TOOL_MINGW32_DLLTOOL ?= $(TOOL_MINGW32_PREFIX)dlltool$(TOOL_MINGW32_HOSTSUFF_EXE)
@@ -236,6 +234,5 @@
 	$(QUIET)$(TOOL_MINGW32_LD) $(flags) -o $(out) $(objs)\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(basename $(lib))), $(lib)))\
-		$(call TOOL_MINGW32_LD_MAP,$(outbase).map)
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(basename $(lib))), $(lib)))
 endef
 
@@ -256,5 +253,5 @@
 TOOL_MINGW32_LINK_DLL_OUTPUT =
 TOOL_MINGW32_LINK_DLL_OUTPUT_MAYBE = $(outbase).a $(outbase).exp $(PATH_LIB)/$(notdir $(outbase)).exp $(PATH_LIB)/$(notdir $(outbase)).a
-## @todo Find a better solution for installing the extra files (.a, .exp, .pdb, .map, etc).
+## @todo Find a better solution for installing the extra files (.a, .exp, .pdb, etc).
 TOOL_MINGW32_LINK_DLL_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib)))\
 	$(filter %.def %.res,$(othersrc))
@@ -269,7 +266,6 @@
 		$(objs)\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(basename $(lib))), $(lib)))\
-		$(call TOOL_MINGW32_LD_MAP,$(outbase).map)
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(basename $(lib))), $(lib)))
 	$(QUIET)$(CP) $(outbase).exp $(outbase).a $(PATH_LIB)/
 endef
-## @todo seperate install stuff!
+## @todo separate install stuff!